diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/rrpaa-wifi-manager.cc ns-3.31/src/wifi/model/rrpaa-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/rrpaa-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/rrpaa-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,12 +49,12 @@
   bool m_adaptiveRtsOn;          //!< Check if Adaptive RTS mechanism is on.
   bool m_lastFrameFail;          //!< Flag if the last frame sent has failed.
   bool m_initialized;            //!< For initializing variables.
-  uint8_t m_nRate;              //!< Number of supported rates.
-  uint8_t m_prevRateIndex;      //!< Rate index of the previous transmission.
-  uint8_t m_rateIndex;          //!< Current rate index.
+  uint8_t m_nRate;               //!< Number of supported rates.
+  uint8_t m_prevRateIndex;       //!< Rate index of the previous transmission.
+  uint8_t m_rateIndex;           //!< Current rate index.
   uint8_t m_prevPowerLevel;      //!< Power level of the previous transmission.
   uint8_t m_powerLevel;          //!< Current power level.
-  RrpaaThresholdsTable m_thresholds;  //!< Rrpaa thresholds for this station.
+  RrpaaThresholdsTable m_thresholds;  //!< RRPAA thresholds for this station.
   RrpaaProbabilitiesTable m_pdTable;  //!< Probability table for power and rate changes.
 };
 
@@ -68,22 +68,22 @@
     .SetGroupName ("Wifi")
     .AddConstructor<RrpaaWifiManager> ()
     .AddAttribute ("Basic",
-                   "If true the RRAA-BASIC algorithm will be used, otherwise the RRAA will be used.",
+                   "If true the RRPAA-BASIC algorithm will be used, otherwise the RRPAA will be used.",
                    BooleanValue (true),
                    MakeBooleanAccessor (&RrpaaWifiManager::m_basic),
                    MakeBooleanChecker ())
     .AddAttribute ("Timeout",
-                   "Timeout for the RRAA-BASIC loss estimation block (s).",
+                   "Timeout for the RRPAA-BASIC loss estimation block.",
                    TimeValue (MilliSeconds (500)),
                    MakeTimeAccessor (&RrpaaWifiManager::m_timeout),
                    MakeTimeChecker ())
     .AddAttribute ("FrameLength",
-                   "The data frame length (in bytes) used for calculating mode TxTime.",
+                   "The Data frame length (in bytes) used for calculating mode TxTime.",
                    UintegerValue (1420),
                    MakeUintegerAccessor (&RrpaaWifiManager::m_frameLength),
                    MakeUintegerChecker <uint32_t> ())
     .AddAttribute ("AckFrameLength",
-                   "The ACK frame length (in bytes) used for calculating mode TxTime.",
+                   "The Ack frame length (in bytes) used for calculating mode TxTime.",
                    UintegerValue (14),
                    MakeUintegerAccessor (&RrpaaWifiManager::m_ackLength),
                    MakeUintegerChecker <uint32_t> ())
@@ -158,7 +158,7 @@
       WifiTxVector txVector;
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
-      /* Calculate the TX Time of the data and the corresponding ACK*/
+      /* Calculate the TX Time of the Data and the corresponding Ack */
       Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetFrequency ());
       Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetFrequency ());
       NS_LOG_DEBUG ("Calculating TX times: Mode= " << mode << " DataTxTime= " << dataTxTime << " AckTxTime= " << ackTxTime);
@@ -342,7 +342,7 @@
 RrpaaWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RrpaaWifiRemoteStation *station = (RrpaaWifiRemoteStation *) st;
+  RrpaaWifiRemoteStation *station = static_cast<RrpaaWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_lastFrameFail = true;
   CheckTimeout (station);
@@ -366,11 +366,11 @@
 }
 
 void
-RrpaaWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                  double ackSnr, WifiMode ackMode, double dataSnr)
+RrpaaWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                  double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  RrpaaWifiRemoteStation *station = (RrpaaWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  RrpaaWifiRemoteStation *station = static_cast<RrpaaWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_lastFrameFail = false;
   CheckTimeout (station);
@@ -392,11 +392,10 @@
 RrpaaWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RrpaaWifiRemoteStation *station = (RrpaaWifiRemoteStation *) st;
+  RrpaaWifiRemoteStation *station = static_cast<RrpaaWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   CheckInit (station);
@@ -421,11 +420,10 @@
 RrpaaWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  RrpaaWifiRemoteStation *station = (RrpaaWifiRemoteStation *) st;
+  RrpaaWifiRemoteStation *station = static_cast<RrpaaWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -444,10 +442,10 @@
 
 bool
 RrpaaWifiManager::DoNeedRts (WifiRemoteStation *st,
-                             Ptr<const Packet> packet, bool normally)
+                             uint32_t size, bool normally)
 {
-  NS_LOG_FUNCTION (this << st << packet << normally);
-  RrpaaWifiRemoteStation *station = (RrpaaWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << size << normally);
+  RrpaaWifiRemoteStation *station = static_cast<RrpaaWifiRemoteStation*> (st);
   CheckInit (station);
   if (m_basic)
     {
@@ -605,17 +603,11 @@
 }
 
 WifiRrpaaThresholds
-RrpaaWifiManager::GetThresholds (RrpaaWifiRemoteStation *station, uint8_t rate) const
+RrpaaWifiManager::GetThresholds (RrpaaWifiRemoteStation *station, uint8_t index) const
 {
-  NS_LOG_FUNCTION (this << station << +rate);
-  WifiMode mode = GetSupported (station, rate);
+  NS_LOG_FUNCTION (this << station << +index);
+  WifiMode mode = GetSupported (station, index);
   return GetThresholds (station, mode);
 }
 
-bool
-RrpaaWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/rrpaa-wifi-manager.h ns-3.31/src/wifi/model/rrpaa-wifi-manager.h
--- ns-3.30.1/src/wifi/model/rrpaa-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/rrpaa-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -45,6 +45,9 @@
  * international conference on Mobile computing and networking (pp. 146-157). ACM.
  * http://ocw.cs.pub.ro/courses/_media/isrm/articole/rrate_adapt_mobicom06.pdf
  *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
  */
 
 /**
@@ -53,7 +56,7 @@
  */
 struct WifiRrpaaThresholds
 {
-  double m_ori; //!< The Oportunistic Rate Increase threshold.
+  double m_ori; //!< The Opportunistic Rate Increase threshold.
   double m_mtl; //!< The Maximum Tolerable Loss threshold.
   uint32_t m_ewnd; //!< The Estimation Window size.
 };
@@ -104,88 +107,87 @@
   virtual void DoReportDataFailed (WifiRemoteStation *station);
   virtual void DoReportRtsOk (WifiRemoteStation *station,
                               double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  virtual void DoReportDataOk (WifiRemoteStation *station,
-                               double ackSnr, WifiMode ackMode, double dataSnr);
+  virtual void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                               double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   virtual void DoReportFinalRtsFailed (WifiRemoteStation *station);
   virtual void DoReportFinalDataFailed (WifiRemoteStation *station);
   virtual WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   virtual WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
   virtual bool DoNeedRts (WifiRemoteStation *st,
-                          Ptr<const Packet> packet, bool normally);
-  virtual bool IsLowLatency (void) const;
+                          uint32_t size, bool normally);
 
   /**
    * Check for initializations.
-   * \param station The remote station.
+   * \param station the remote station.
    */
   void CheckInit (RrpaaWifiRemoteStation *station);
 
   /**
    * Check if the counter should be reset.
    *
-   * \param station
+   * \param station the remote station
    */
   void CheckTimeout (RrpaaWifiRemoteStation *station);
   /**
    * Find an appropriate rate and power for the given station, using
    * a basic algorithm.
    *
-   * \param station
+   * \param station the remote station
    */
   void RunBasicAlgorithm (RrpaaWifiRemoteStation *station);
   /**
    * Run an enhanced algorithm which activates the use of RTS
    * for the given station if the conditions are met.
    *
-   * \param station
+   * \param station the remote station
    */
   void RunAdaptiveRtsAlgorithm (RrpaaWifiRemoteStation *station);
   /**
    * Reset the counters of the given station.
    *
-   * \param station
+   * \param station the remote station
    */
   void ResetCountersBasic (RrpaaWifiRemoteStation *station);
 
   /**
    * Initialize the thresholds internal list for the given station.
    *
-   * \param station
+   * \param station the remote station
    */
   void InitThresholds (RrpaaWifiRemoteStation *station);
 
   /**
    * Get the thresholds for the given station and mode.
    *
-   * \param station
-   * \param mode
+   * \param station the remote station
+   * \param mode the WifiMode
    *
-   * \return threshold
+   * \return the RRPAA thresholds
    */
   WifiRrpaaThresholds GetThresholds (RrpaaWifiRemoteStation *station, WifiMode mode) const;
 
   /**
    * Get the thresholds for the given station and mode index.
    *
-   * \param station
-   * \param rate
+   * \param station the remote station
+   * \param index the mode index in the supported rates
    *
-   * \return threshold
+   * \return the RRPAA thresholds
    */
-  WifiRrpaaThresholds GetThresholds (RrpaaWifiRemoteStation *station, uint8_t rate) const;
+  WifiRrpaaThresholds GetThresholds (RrpaaWifiRemoteStation *station, uint8_t index) const;
 
   /**
    * Get the estimated TxTime of a packet with a given mode.
    *
-   * \param mode
+   * \param mode the WifiMode
    *
-   * \return time
+   * \return the estimated TX time
    */
   Time GetCalcTxTime (WifiMode mode) const;
   /**
    * Add transmission time for the given mode to an internal list.
    *
-   * \param mode Wi-Fi mode
+   * \param mode the WifiMode
    * \param t transmission time
    */
   void AddCalcTxTime (WifiMode mode, Time t);
@@ -201,8 +203,8 @@
   Time m_sifs;             //!< Value of SIFS configured in the device.
   Time m_difs;             //!< Value of DIFS configured in the device.
 
-  uint32_t m_frameLength;  //!< Data frame length used for calculate mode TxTime.
-  uint32_t m_ackLength;    //!< Ack frame length used for calculate mode TxTime.
+  uint32_t m_frameLength;  //!< Data frame length used for calculate mode TxTime (in bytes).
+  uint32_t m_ackLength;    //!< Ack frame length used for calculate mode TxTime (in bytes).
 
   bool m_basic;            //!< If using the basic algorithm (without RTS/CTS).
   Time m_timeout;          //!< Timeout for the RRAA BASIC loss estimation block.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/simple-frame-capture-model.h ns-3.31/src/wifi/model/simple-frame-capture-model.h
--- ns-3.30.1/src/wifi/model/simple-frame-capture-model.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/simple-frame-capture-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -73,7 +73,7 @@
 
 
 private:
-  double m_margin; ///< margin for determining if a new frame
+  double m_margin; ///< margin for determining if a new frame (dB)
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/snr-tag.cc ns-3.31/src/wifi/model/snr-tag.cc
--- ns-3.30.1/src/wifi/model/snr-tag.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/snr-tag.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,7 +36,7 @@
     .SetParent<Tag> ()
     .SetGroupName ("Wifi")
     .AddConstructor<SnrTag> ()
-    .AddAttribute ("Snr", "The snr of the last packet received",
+    .AddAttribute ("Snr", "The SNR of the last packet received",
                    DoubleValue (0.0),
                    MakeDoubleAccessor (&SnrTag::Get),
                    MakeDoubleChecker<double> ())
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/snr-tag.h ns-3.31/src/wifi/model/snr-tag.h
--- ns-3.30.1/src/wifi/model/snr-tag.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/snr-tag.h	2020-06-27 17:38:30.000000000 -0700
@@ -42,7 +42,7 @@
   TypeId GetInstanceTypeId (void) const;
 
   /**
-   * Create a SnrTag with the default snr 0
+   * Create a SnrTag with the default SNR 0
    */
   SnrTag ();
 
@@ -54,19 +54,19 @@
   /**
    * Set the SNR to the given value.
    *
-   * \param snr the value of the snr to set
+   * \param snr the value of the SNR to set in linear scale
    */
   void Set (double snr);
   /**
    * Return the SNR value.
    *
-   * \return the SNR value
+   * \return the SNR value in linear scale
    */
   double Get (void) const;
 
 
 private:
-  double m_snr;  //!< SNR value
+  double m_snr;  //!< SNR value in linear scale
 };
 
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/spectrum-wifi-phy.cc ns-3.31/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.30.1/src/wifi/model/spectrum-wifi-phy.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/spectrum-wifi-phy.cc	2020-06-27 17:38:30.000000000 -0700
@@ -32,6 +32,8 @@
 #include "wifi-spectrum-signal-parameters.h"
 #include "wifi-spectrum-phy-interface.h"
 #include "wifi-utils.h"
+#include "wifi-ppdu.h"
+#include "wifi-psdu.h"
 
 namespace ns3 {
 
@@ -217,7 +219,7 @@
   m_signalCb (wifiRxParams ? true : false, senderNodeId, WToDbm (rxPowerW), rxDuration);
 
   // Do no further processing if signal is too weak
-  // Current implementation assumes constant rx power over the packet duration
+  // Current implementation assumes constant RX power over the PPDU duration
   if (WToDbm (rxPowerW) < GetRxSensitivity ())
     {
       NS_LOG_INFO ("Received signal too weak to process: " << WToDbm (rxPowerW) << " dBm");
@@ -239,8 +241,8 @@
     }
 
   NS_LOG_INFO ("Received Wi-Fi signal");
-  Ptr<Packet> packet = wifiRxParams->packet->Copy ();
-  StartReceivePreamble (packet, rxPowerW, rxDuration);
+  Ptr<WifiPpdu> ppdu = Copy (wifiRxParams->ppdu);
+  StartReceivePreamble (ppdu, rxPowerW);
 }
 
 Ptr<AntennaModel>
@@ -311,28 +313,30 @@
 }
 
 void
-SpectrumWifiPhy::StartTx (Ptr<Packet> packet, WifiTxVector txVector, Time txDuration)
+SpectrumWifiPhy::StartTx (Ptr<WifiPpdu> ppdu)
 {
+  NS_LOG_FUNCTION (this << ppdu);
+  WifiTxVector txVector = ppdu->GetTxVector ();
   double txPowerDbm = GetTxPowerForTransmission (txVector) + GetTxGain ();
   NS_LOG_DEBUG ("Start transmission: signal power before antenna gain=" << txPowerDbm << "dBm");
   double txPowerWatts = DbmToW (txPowerDbm);
   Ptr<SpectrumValue> txPowerSpectrum = GetTxPowerSpectralDensity (GetCenterFrequencyForChannelWidth (txVector), txVector.GetChannelWidth (), txPowerWatts, txVector.GetMode ().GetModulationClass ());
   Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters> ();
-  txParams->duration = txDuration;
+  txParams->duration = ppdu->GetTxDuration ();
   txParams->psd = txPowerSpectrum;
   NS_ASSERT_MSG (m_wifiSpectrumPhyInterface, "SpectrumPhy() is not set; maybe forgot to call CreateWifiSpectrumPhyInterface?");
   txParams->txPhy = m_wifiSpectrumPhyInterface->GetObject<SpectrumPhy> ();
   txParams->txAntenna = m_antenna;
-  txParams->packet = packet;
+  txParams->ppdu = ppdu;
   NS_LOG_DEBUG ("Starting transmission with power " << WToDbm (txPowerWatts) << " dBm on channel " << +GetChannelNumber ());
   NS_LOG_DEBUG ("Starting transmission with integrated spectrum power " << WToDbm (Integral (*txPowerSpectrum)) << " dBm; spectrum model Uid: " << txPowerSpectrum->GetSpectrumModel ()->GetUid ());
   m_channel->StartTx (txParams);
 }
 
-double
+uint32_t
 SpectrumWifiPhy::GetBandBandwidth (void) const
 {
-  double bandBandwidth = 0;
+  uint32_t bandBandwidth = 0;
   switch (GetStandard ())
     {
     case WIFI_PHY_STANDARD_80211a:
@@ -371,7 +375,7 @@
   uint16_t guardBandwidth = 0;
   if (currentChannelWidth == 22)
     {
-      //handle case of use of legacy DSSS transmission
+      //handle case of DSSS transmission
       guardBandwidth = 10;
     }
   else
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/spectrum-wifi-phy.h ns-3.31/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.30.1/src/wifi/model/spectrum-wifi-phy.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/spectrum-wifi-phy.h	2020-06-27 17:38:30.000000000 -0700
@@ -34,6 +34,7 @@
 namespace ns3 {
 
 class WifiSpectrumPhyInterface;
+class WifiPpdu;
 
 /**
  * \brief 802.11 PHY layer model
@@ -59,6 +60,10 @@
   SpectrumWifiPhy ();
   virtual ~SpectrumWifiPhy ();
 
+  // Implementation of pure virtual method.
+  void StartTx (Ptr<WifiPpdu> ppdu);
+  Ptr<Channel> GetChannel (void) const;
+
   /**
    * Set the SpectrumChannel this SpectrumWifiPhy is to be connected to.
    *
@@ -68,27 +73,19 @@
 
   /**
    * Input method for delivering a signal from the spectrum channel
-   * and low-level Phy interface to this SpectrumWifiPhy instance.
+   * and low-level PHY interface to this SpectrumWifiPhy instance.
    *
    * \param rxParams Input signal parameters
    */
   void StartRx (Ptr<SpectrumSignalParameters> rxParams);
 
   /**
-   * \param packet the packet to send
-   * \param txVector the TXVECTOR that has tx parameters such as mode, the transmission mode to use to send
-   *        this packet, and txPowerLevel, a power level to use to send this packet. The real transmission
-   *        power is calculated as txPowerMin + txPowerLevel * (txPowerMax - txPowerMin) / nTxLevels
-   * \param txDuration duration of the transmission.
-   */
-  void StartTx (Ptr<Packet> packet, WifiTxVector txVector, Time txDuration);
-  /**
    * Get the center frequency of the channel corresponding the current TxVector rather than
    * that of the supported channel width.
    * Consider that this "primary channel" is on the lower part for the time being.
    *
    * \param txVector the TXVECTOR that has the channel width that is to be used
-   * \return the center frequency corresponding to the channel width to be used
+   * \return the center frequency in MHz corresponding to the channel width to be used
    */
   uint16_t GetCenterFrequencyForChannelWidth (WifiTxVector txVector) const;
 
@@ -102,14 +99,14 @@
   void CreateWifiSpectrumPhyInterface (Ptr<NetDevice> device);
   /**
    * \param antenna an AntennaModel to include in the transmitted
-   * SpectrumSignalParameters (in case any objects downstream of the
-   * SpectrumWifiPhy wish to adjust signal properties based on the
-   * transmitted antenna model.  This antenna is also used when
-   * the underlying WifiSpectrumPhyInterface::GetRxAntenna() method
-   * is called.
+   *                SpectrumSignalParameters (in case any objects downstream of the
+   *                SpectrumWifiPhy wish to adjust signal properties based on the
+   *                transmitted antenna model.  This antenna is also used when
+   *                the underlying WifiSpectrumPhyInterface::GetRxAntenna() method
+   *                is called.
    *
    * Note:  this method may be split into separate SetTx and SetRx
-   * methods in the future if the modelling need for this arises
+   * methods in the future if the modeling need for this arises
    */
   void SetAntenna (const Ptr<AntennaModel> antenna);
   /**
@@ -119,16 +116,16 @@
    */
   Ptr<AntennaModel> GetRxAntenna (void) const;
   /**
-   * \return returns the SpectrumModel that this SpectrumPhy expects to be used
-   * for all SpectrumValues that are passed to StartRx. If 0 is
-   * returned, it means that any model will be accepted.
+   * \return the SpectrumModel that this SpectrumPhy expects to be used
+   *         for all SpectrumValues that are passed to StartRx. If 0 is
+   *         returned, it means that any model will be accepted.
    */
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
 
   /**
    * \return the width of each band (Hz)
    */
-  double GetBandBandwidth (void) const;
+  uint32_t GetBandBandwidth (void) const;
 
   /**
    * \param currentChannelWidth channel width of the current transmission (MHz)
@@ -144,7 +141,7 @@
   uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const;
 
   /**
-   * Callback invoked when the Phy model starts to process a signal
+   * Callback invoked when the PHY model starts to process a signal
    *
    * \param signalType Whether signal is WiFi (true) or foreign (false)
    * \param senderNodeId Node Id of the sender of the signal
@@ -153,17 +150,11 @@
    */
   typedef void (* SignalArrivalCallback) (bool signalType, uint32_t senderNodeId, double rxPower, Time duration);
 
-  Ptr<Channel> GetChannel (void) const;
-
   // The following four methods call to the base WifiPhy class method
   // but also generate a new SpectrumModel if called during runtime
-
   virtual void SetChannelNumber (uint8_t id);
-
   virtual void SetFrequency (uint16_t freq);
-
   virtual void SetChannelWidth (uint16_t channelwidth);
-
   virtual void ConfigureStandard (WifiPhyStandard standard);
 
 protected:
@@ -178,9 +169,9 @@
    * \param channelWidth channel width (MHz) of the channel for the current transmission
    * \param txPowerW power in W to spread across the bands
    * \param modulationClass the modulation class
-   * \return Ptr to SpectrumValue
+   * \return Pointer to SpectrumValue
    *
-   * This is a helper function to create the right Tx PSD corresponding
+   * This is a helper function to create the right TX PSD corresponding
    * to the standard in use.
    */
   Ptr<SpectrumValue> GetTxPowerSpectralDensity (uint16_t centerFrequency, uint16_t channelWidth, double txPowerW, WifiModulationClass modulationClass) const;
@@ -192,11 +183,11 @@
 
   Ptr<SpectrumChannel> m_channel;        //!< SpectrumChannel that this SpectrumWifiPhy is connected to
 
-  Ptr<WifiSpectrumPhyInterface> m_wifiSpectrumPhyInterface; //!< Spectrum phy interface
-  Ptr<AntennaModel> m_antenna; //!< antenna model
-  mutable Ptr<const SpectrumModel> m_rxSpectrumModel; //!< receive spectrum model
-  bool m_disableWifiReception;          //!< forces this Phy to fail to sync on any signal
-  TracedCallback<bool, uint32_t, double, Time> m_signalCb; //!< Signal callback
+  Ptr<WifiSpectrumPhyInterface> m_wifiSpectrumPhyInterface; //!< Spectrum PHY interface
+  Ptr<AntennaModel> m_antenna;                              //!< antenna model
+  mutable Ptr<const SpectrumModel> m_rxSpectrumModel;       //!< receive spectrum model
+  bool m_disableWifiReception;                              //!< forces this PHY to fail to sync on any signal
+  TracedCallback<bool, uint32_t, double, Time> m_signalCb;  //!< Signal callback
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ssid.cc ns-3.31/src/wifi/model/ssid.cc
--- ns-3.30.1/src/wifi/model/ssid.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ssid.cc	2020-06-27 17:38:30.000000000 -0700
@@ -117,14 +117,6 @@
 
 ATTRIBUTE_HELPER_CPP (Ssid);
 
-/**
- * Serialize SSID to the given ostream
- *
- * \param os
- * \param ssid
- *
- * \return std::ostream
- */
 std::ostream &
 operator << (std::ostream &os, const Ssid &ssid)
 {
@@ -132,15 +124,8 @@
   return os;
 }
 
-/**
- * Serialize from the given istream to this SSID.
- *
- * \param is
- * \param ssid
- *
- * \return std::istream
- */
-std::istream &operator >> (std::istream &is, Ssid &ssid)
+std::istream &
+operator >> (std::istream &is, Ssid &ssid)
 {
   std::string str;
   is >> str;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ssid.h ns-3.31/src/wifi/model/ssid.h
--- ns-3.30.1/src/wifi/model/ssid.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ssid.h	2020-06-27 17:38:30.000000000 -0700
@@ -35,7 +35,9 @@
 class Ssid : public WifiInformationElement
 {
 public:
-  // broadcast ssid
+  /**
+   * Create SSID with broadcast SSID
+   */
   Ssid ();
   /**
    * Create SSID from a given string
@@ -44,6 +46,13 @@
    */
   Ssid (std::string s);
 
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const;
+  uint8_t GetInformationFieldSize () const;
+  void SerializeInformationField (Buffer::Iterator start) const;
+  uint8_t DeserializeInformationField (Buffer::Iterator start,
+                                       uint8_t length);
+
   /**
    * Check if the two SSIDs are equal.
    *
@@ -68,43 +77,29 @@
    */
   char* PeekString (void) const;
 
-  /**
-   * Get the ElementID.
-   *
-   * \returns the element ID
-   */
-  WifiInformationElementId ElementId () const;
-
-  /**
-   * Get the information field size.
-   *
-   * \returns the information field size
-   */
-  uint8_t GetInformationFieldSize () const;
-
-  /**
-   * Get the information field size.
-   *
-   * \param start the information field iterator
-   */
-  void SerializeInformationField (Buffer::Iterator start) const;
-
-  /**
-   * Get the information field size.
-   *
-   * \param start the information field iterator
-   * \param length the size of the information field
-   * \returns the size of the field read
-   */
-  uint8_t DeserializeInformationField (Buffer::Iterator start,
-                                       uint8_t length);
 
 private:
   uint8_t m_ssid[33]; //!< Raw SSID value
   uint8_t m_length;   //!< Length of the SSID
 };
 
+/**
+ * Serialize SSID to the given ostream
+ *
+ * \param os the output stream
+ * \param ssid the SSID
+ *
+ * \return std::ostream
+ */
 std::ostream &operator << (std::ostream &os, const Ssid &ssid);
+/**
+ * Serialize from the given istream to this SSID.
+ *
+ * \param is the input stream
+ * \param ssid the SSID
+ *
+ * \return std::istream
+ */
 std::istream &operator >> (std::istream &is, Ssid &ssid);
 
 ATTRIBUTE_HELPER_HEADER (Ssid);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/status-code.cc ns-3.31/src/wifi/model/status-code.cc
--- ns-3.30.1/src/wifi/model/status-code.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/status-code.cc	2020-06-27 17:38:30.000000000 -0700
@@ -64,14 +64,6 @@
   return start;
 }
 
-/**
- * Serialize StatusCode to the given ostream.
- *
- * \param os
- * \param code
- *
- * \return std::ostream
- */
 std::ostream &
 operator << (std::ostream &os, const StatusCode &code)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/status-code.h ns-3.31/src/wifi/model/status-code.h
--- ns-3.30.1/src/wifi/model/status-code.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/status-code.h	2020-06-27 17:38:30.000000000 -0700
@@ -82,6 +82,14 @@
   uint16_t m_code; ///< status code
 };
 
+/**
+ * Serialize StatusCode to the given ostream.
+ *
+ * \param os the output stream
+ * \param code the StatusCode
+ *
+ * \return std::ostream
+ */
 std::ostream &operator << (std::ostream &os, const StatusCode &code);
 
 } //namespace ns3
